Bug 784175 - Review Request: SuperLU - Subroutines to solve sparse linear systems
Summary: Review Request: SuperLU - Subroutines to solve sparse linear systems
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jerry James
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2012-01-24 05:36 UTC by Shakthi Kannan
Modified: 2014-01-06 13:12 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-09-09 02:48:13 UTC
Type: ---
loganjerry: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Shakthi Kannan 2012-01-24 05:36:50 UTC
Spec URL: http://shakthimaan.fedorapeople.org/SPECS/SuperLU.spec
SRPM URL: http://shakthimaan.fedorapeople.org/SRPMS/SuperLU-4.3-1.fc15.src.rpm
Description: SuperLU contains a set of subroutines to solve a sparse linear system A*X=B. It uses Gaussian elimination with partial pivoting (GEPP). 
The columns of A may be preordered before factorization; the 
preordering for sparsity is completely separate from the factorization.

Comment 1 Shakthi Kannan 2012-01-24 05:39:18 UTC
$  rpmlint SuperLU.spec
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

$  rpmlint SuperLU-4.3-1.fc15.src.rpm 
SuperLU.src: W: spelling-error %description -l en_US preordered -> reordered, p reordered, prerecorded
SuperLU.src: W: spelling-error %description -l en_US preordering -> reordering, p reordering, preordaining
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

$  rpmlint SuperLU-4.3-1.fc15.x86_64.rpm 
SuperLU.x86_64: W: spelling-error %description -l en_US preordered -> reordered, p reordered, prerecorded
SuperLU.x86_64: W: spelling-error %description -l en_US preordering -> reordering, p reordering, preordaining
SuperLU.x86_64: W: shared-lib-calls-exit /usr/lib64/libsuperlu.so.4.3 exit@GLIBC_2.2.5
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

$  rpmlint SuperLU-devel-4.3-1.fc15.x86_64.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

Successful Koji builds for F15, F16, F17 and EL6:

http://koji.fedoraproject.org/koji/taskinfo?taskID=3727885
http://koji.fedoraproject.org/koji/taskinfo?taskID=3727890
http://koji.fedoraproject.org/koji/taskinfo?taskID=3727892
http://koji.fedoraproject.org/koji/taskinfo?taskID=3727895

Comment 2 Chitlesh GOORAH 2012-01-24 06:50:47 UTC
Hello Shakthi,

It appears that the CFLAGS are not parsed correctly.

http://koji.fedoraproject.org/koji/getfile?taskID=3727891&name=build.log

Comment 3 Susi Lehtola 2012-01-24 07:56:24 UTC
Don't build against reference BLAS. Use ATLAS instead, it's an order of magnitude faster. To link against the ATLAS BLAS library use "-L%{_libdir}/atlas -lf77blas -latlas".

You also might want to use "%{version}" instead of "4.3" in the spec file, e.g. in %setup.

Comment 4 Shakthi Kannan 2012-02-01 12:18:53 UTC
I have updated:

* to use RPM_OPT_FLAGS and LIBS when building the sources
* to use Atlas library instead of blas
* Replaced names and version with their respective macros

SPEC: http://shakthimaan.fedorapeople.org/SPECS/SuperLU.spec
SRPM: http://shakthimaan.fedorapeople.org/SRPMS/SuperLU-4.3-2.fc15.src.rpm

Successful Koji builds for F15, F16, F17 and EL6:

http://koji.fedoraproject.org/koji/taskinfo?taskID=3751616
http://koji.fedoraproject.org/koji/taskinfo?taskID=3751621
http://koji.fedoraproject.org/koji/taskinfo?taskID=3751625
http://koji.fedoraproject.org/koji/taskinfo?taskID=3751623

$ rpmlint SuperLU.spec
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

$ rpmlint SuperLU-4.3-2.fc15.src.rpm 
SuperLU.src: W: spelling-error %description -l en_US preordered -> reordered, p reordered, prerecorded
SuperLU.src: W: spelling-error %description -l en_US preordering -> reordering, p reordering, preordaining
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

$ rpmlint SuperLU-4.3-2.fc15.x86_64.rpm 
SuperLU.x86_64: W: spelling-error %description -l en_US preordered -> reordered, p reordered, prerecorded
SuperLU.x86_64: W: spelling-error %description -l en_US preordering -> reordering, p reordering, preordaining
SuperLU.x86_64: W: shared-lib-calls-exit /usr/lib64/libsuperlu.so.4.3 exit@GLIBC_2.2.5
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

$ rpmlint SuperLU-devel-4.3-2.fc15.x86_64.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

Comment 5 Jerry James 2012-08-09 20:01:59 UTC
Chitlesh, do you intend to continue with this review?

Comment 6 Jerry James 2012-08-17 15:49:59 UTC
Chitlesh, this review is stalled.  As per https://fedoraproject.org/wiki/Policy_for_stalled_package_reviews#Reviewer_not_responding, please respond within the next week.

Shakthi, are you still ready to move forward with this review?

Comment 7 Shakthi Kannan 2012-08-17 15:54:47 UTC
Yes. It would be good if someone can review this package.

Comment 8 Jerry James 2012-08-24 20:04:07 UTC
Chitlesh has not responded here, nor to private email.  I will take over the review.

Comment 9 Jerry James 2012-08-24 20:06:03 UTC
There are a few things to fix, all of them minor, and some of them optional.

1) I think the two %doc lines should be switched.  The README file contains
   the license text, so it should be in the main package.  The material in DOC
   is suitable for a developer of the library, rather than a user, so it
   should be in the -devel package.

2) Unless you plan to use the same spec file for EPEL5, remove
   "rm -rf %{buildroot}" from %install, and %defattr from both %files
   sections.

3) Ask upstream to avoid calling exit() in a library.

4) Add "chmod a-x SRC/qselect.c" to %prep to get rid of the
   spurious-executable-perm warning from rpmlint.

5) Remove "-latlas" from the last sed expression in %prep.  The f77blas
   library is already linked against libatlas.  Removing explicit mention of
   it from the link line gets rid of the unused-direct-shlib-dependency
   warning from rpmlint.

6) Add comments about the upstream status of the patches (optional).  See
   https://fedoraproject.org/wiki/Packaging:Guidelines#All_patches_should_have_an_upstream_bug_link_or_comment

7) Change the patch names to "%{name}-add-fpic.patch", etc.  That hushes up
   one of the complaints in the SHOULD section below (optional).

8) Add a %check script to run the tests in TESTING (optional).


Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== C/C++ ====
[x]: MUST Header files in -devel subpackage, if present.
[x]: MUST ldconfig called in %post and %postun if required.
[x]: MUST Package does not contain any libtool archives (.la)
[x]: MUST Package does not contain kernel modules.
[x]: MUST Package contains no static executables.
[x]: MUST Rpath absent or only used for internal libs.
[x]: MUST Development (unversioned) .so files in -devel subpackage, if
     present.


==== Generic ====
[x]: EXTRA Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: EXTRA Spec file according to URL is the same as in SRPM.
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Sources contain only permissible code or content.
[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files devel section. This is OK if
     packaging for EPEL5. Otherwise not needed
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[x]: MUST Package contains desktop file if it is a GUI application.
[x]: MUST Development files must be in a -devel package
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Fully versioned dependency in subpackages, if present.
[x]: MUST Package complies to the Packaging Guidelines
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
[x]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (with incorrect FSF address)" For detailed output of licensecheck
     see file: /home/jamesjer/784175-SuperLU/licensecheck.txt
[!]: MUST License file installed when any subpackage combination is installed.
[x]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: MUST Package is named using only allowed ascii characters.
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[x]: MUST If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Package is not relocatable.
[x]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: MUST Package contains systemd file(s) if in need.
[x]: MUST File names are valid UTF-8.
[x]: MUST Useful -debuginfo package or justification otherwise.
[x]: SHOULD Reviewer should test that the package builds in mock.
[x]: SHOULD Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: SHOULD Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL5 is required
[x]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: SHOULD Package functions as described.
[x]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[!]: SHOULD Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: SHOULD Scriptlets must be sane, if used.
[x]: SHOULD SourceX tarball generation or download is documented.
[!]: SHOULD SourceX / PatchY prefixed with %{name}.
     Note: Source0 (superlu_4.3.tar.gz)
[x]: SHOULD SourceX is a working URL.
[x]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[!]: SHOULD %check is present and all tests pass.
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.

Issues:
[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files devel section. This is OK if
     packaging for EPEL5. Otherwise not needed
See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
See: None
[!]: MUST License file installed when any subpackage combination is installed.
     The license file is README, which is in -devel.  Move it to the main
     package to satisfy this requirement.

Rpmlint
-------
Checking: SuperLU-4.3-2.fc17.x86_64.rpm
	  SuperLU-devel-4.3-2.fc17.x86_64.rpm
	  SuperLU-4.3-2.fc17.src.rpm
	  SuperLU-debuginfo-4.3-2.fc17.x86_64.rpm
SuperLU.x86_64: W: spelling-error %description -l en_US preordered -> reordered, p reordered, prerecorded
SuperLU.x86_64: W: spelling-error %description -l en_US preordering -> reordering, p reordering, preordaining
SuperLU.x86_64: W: shared-lib-calls-exit /usr/lib64/libsuperlu.so.4.3 exit@GLIBC_2.2.5
SuperLU.src: W: spelling-error %description -l en_US preordered -> reordered, p reordered, prerecorded
SuperLU.src: W: spelling-error %description -l en_US preordering -> reordering, p reordering, preordaining
SuperLU-debuginfo.x86_64: W: spurious-executable-perm /usr/src/debug/SuperLU_4.3/SRC/qselect.c
4 packages and 0 specfiles checked; 0 errors, 6 warnings.


Rpmlint (installed packages)
----------------------------
# rpmlint SuperLU-devel
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'

Requires
--------
SuperLU-4.3-2.fc17.x86_64.rpm (rpmlib, GLIBC filtered):

    /sbin/ldconfig
    libatlas.so.3()(64bit)
    libc.so.6()(64bit)
    libf77blas.so.3()(64bit)
    rtld(GNU_HASH)

SuperLU-devel-4.3-2.fc17.x86_64.rpm (rpmlib, GLIBC filtered):

    SuperLU = 4.3-2.fc17
    libsuperlu.so.4.3()(64bit)
    pkgconfig

SuperLU-debuginfo-4.3-2.fc17.x86_64.rpm (rpmlib, GLIBC filtered):


Provides
--------
SuperLU-4.3-2.fc17.x86_64.rpm:

    SuperLU = 4.3-2.fc17
    SuperLU(x86-64) = 4.3-2.fc17
    libsuperlu.so.4.3()(64bit)

SuperLU-devel-4.3-2.fc17.x86_64.rpm:

    SuperLU-devel = 4.3-2.fc17
    SuperLU-devel(x86-64) = 4.3-2.fc17

SuperLU-debuginfo-4.3-2.fc17.x86_64.rpm:

    SuperLU-debuginfo = 4.3-2.fc17
    SuperLU-debuginfo(x86-64) = 4.3-2.fc17

MD5-sum check
-------------
http://crd-legacy.lbl.gov/~xiaoye/SuperLU/superlu_4.3.tar.gz :
  CHECKSUM(SHA256) this package     : 169920322eb9b9c6a334674231479d04df72440257c17870aaa0139d74416781
  CHECKSUM(SHA256) upstream package : 169920322eb9b9c6a334674231479d04df72440257c17870aaa0139d74416781


Generated by fedora-review 0.2.2 (9f8c0e5) last change: 2012-08-09
Command line :/usr/bin/fedora-review -b 784175
External plugins:

Comment 10 Shakthi Kannan 2012-08-25 10:45:23 UTC
Thanks for the review.

I have made the following changes:

- Use README in main package and DOC in devel package
- chmod a-x on SRC/qselect.c
- Remove -latlas linking in prep section
- Added Patch comments
- Use name RPM macro in patch name

Will inform upstream about not using exit in the library. 

I would like the package to be made available for EPEL5, and hence have not removed "rm -rf %{buildroot}" from %install, and %defattr from both %files sections.

I haven't added the testing check, because, it uses the static library, which we don't build now.

Updated:
SPEC: http://shakthimaan.fedorapeople.org/SPECS/SuperLU.spec
SRPM: http://shakthimaan.fedorapeople.org/SRPMS/SuperLU-4.3-3.fc16.src.rpm

Successful Koji builds for F16, F17 and F18 respectively:

http://koji.fedoraproject.org/koji/taskinfo?taskID=4421670
http://koji.fedoraproject.org/koji/taskinfo?taskID=4421679
http://koji.fedoraproject.org/koji/taskinfo?taskID=4421684

$ rpmlint SuperLU.spec
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

$ rpmlint SuperLU-4.3-3.fc16.src.rpm 
SuperLU.src: W: spelling-error %description -l en_US preordered -> reordered, p reordered, prerecorded
SuperLU.src: W: spelling-error %description -l en_US preordering -> reordering, p reordering, preordaining
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

$ rpmlint SuperLU-4.3-3.fc16.x86_64.rpm 
SuperLU.x86_64: W: spelling-error %description -l en_US preordered -> reordered, p reordered, prerecorded
SuperLU.x86_64: W: spelling-error %description -l en_US preordering -> reordering, p reordering, preordaining
SuperLU.x86_64: W: shared-lib-calls-exit /usr/lib64/libsuperlu.so.4.3 exit@GLIBC_2.2.5
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

$ rpmlint SuperLU-devel-4.3-3.fc16.x86_64.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

Comment 11 Jerry James 2012-08-27 22:26:20 UTC
OK, it looks great.  This package is APPROVED.

Comment 12 Shakthi Kannan 2012-08-29 16:55:00 UTC
Thanks for the review.

New Package SCM Request
=======================
Package Name: SuperLU
Short Description: Subroutines to solve sparse linear systems
Owners: shakthimaan
Branches: f16 f17 f18
InitialCC: shakthimaan

Comment 13 Gwyn Ciesla 2012-08-29 17:23:58 UTC
Git done (by process-git-requests).

Comment 14 Fedora Update System 2012-08-31 09:02:40 UTC
SuperLU-4.3-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/SuperLU-4.3-3.fc17

Comment 15 Fedora Update System 2012-08-31 09:02:55 UTC
SuperLU-4.3-3.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/SuperLU-4.3-3.fc16

Comment 16 Fedora Update System 2012-08-31 09:03:07 UTC
SuperLU-4.3-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/SuperLU-4.3-3.fc18

Comment 17 Fedora Update System 2012-08-31 16:01:09 UTC
SuperLU-4.3-3.fc18 has been pushed to the Fedora 18 testing repository.

Comment 18 Fedora Update System 2012-09-09 02:48:13 UTC
SuperLU-4.3-3.fc16 has been pushed to the Fedora 16 stable repository.

Comment 19 Fedora Update System 2012-09-09 02:54:57 UTC
SuperLU-4.3-3.fc17 has been pushed to the Fedora 17 stable repository.

Comment 20 Fedora Update System 2012-09-17 22:09:06 UTC
SuperLU-4.3-3.fc18 has been pushed to the Fedora 18 stable repository.

Comment 21 Björn 'besser82' Esser 2014-01-06 12:31:11 UTC
Package Change Request
======================
Package Name: SuperLU
New Branches: el5 el6
Owners: besser82 shakthimaan
InitialCC: ml-sig

I want to build this for el <= 6, because this is a BR for my WIP eigen3 = 3.2.0 for those epel-branches.

Comment 22 Gwyn Ciesla 2014-01-06 13:12:36 UTC
Git done (by process-git-requests).


Note You need to log in before you can comment on or make changes to this bug.